// DlgProxy.h : header file
//

#if !defined(AFX_DLGPROXY_H__FA48B199_B231_4E5E_963E_CADDA08FD3BB__INCLUDED_)
#define AFX_DLGPROXY_H__FA48B199_B231_4E5E_963E_CADDA08FD3BB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CJabAppDlg;
#include <afxtempl.h>

/////////////////////////////////////////////////////////////////////////////
// CJabEventsSink command target
#import "H:\\jabbercom\\jabbercom.tlb"

static const IID IID_IJabberSessionEventSink = __uuidof(JabberCOM::IJabberSessionEvents);

class CJabEventsSink : public CCmdTarget
{
	DECLARE_DYNCREATE(CJabEventsSink)

	CJabEventsSink();           // protected constructor used by dynamic creation
	JabberCOM::IJabberSessionPtr m_pJabberSession;
	LPUNKNOWN pUnkSink ;
	BOOL m_bCOMInitialized ; 
	BOOL initCOMLibrary()  ; 
	DWORD m_dwCookie ;

// Attributes
public:
	CJabAppDlg* m_pDialog;

// Operations
public:
	BOOL sendMsg(LPCTSTR msg , LPCTSTR toJID);
	BOOL Connect(LPCTSTR szUserName, LPCTSTR szPassword, LPCTSTR szServer, LPCTSTR szResource, BOOL bNewUser);
	BOOL Disconnect(BOOL bImmediate) ;
	JabberCOM::IJabberRosterPtr GetRoster();
	JabberCOM::IJabberPresPtr   GetPres(BSTR jid);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJabEventsSink)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CJabEventsSink();

	// Generated message map functions
	//{{AFX_MSG(CJabEventsSink)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(CJabEventsSink)

	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CJabEventsSink)
		// NOTE - the ClassWizard will add and remove member functions here.
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnAuthError(LPCTSTR txt);
	afx_msg void OnCommError(LPCTSTR txt);
	afx_msg void OnQueryError(LPCTSTR txt, LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnRosterStart();
	afx_msg void OnRosterItem(JabberCOM::IJabberRosterItemPtr item);
	afx_msg void OnRosterEnd();
	afx_msg void OnMessage(JabberCOM::IJabberMsgPtr message, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnPresence(LPCTSTR presJID, BOOL available, LPCTSTR status, BOOL inRoster, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnSubscriptionRequest(LPCTSTR fromJID, LPCTSTR subType, LPCTSTR status);
	afx_msg void OnSubscriptionApproved(LPCTSTR fromJID, LPCTSTR status);
	afx_msg void OnSubscriptionDenied(LPCTSTR fromJID, LPCTSTR status);
	afx_msg void OnXML(long direction, LPCTSTR txt);
	afx_msg void OnJabberIQ(LPCTSTR nSpace, JabberCOM::IJabberIQPtr IQ);
	afx_msg void OnUnhandledQuery(LPCTSTR nSpace, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnAgentsStart();
	afx_msg void OnAgentItem(JabberCOM::IJabberAgentItemPtr agent, LPCTSTR iqID);
	afx_msg void OnAgentsEnd();
	afx_msg void OnXMLTag(JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnVersionGet(LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnTimeGet(LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag);
	afx_msg void OnGetOOB(LPCTSTR fromJID, LPCTSTR URL, LPCTSTR desc, JabberCOM::IXMLTagPtr xmlTag);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGPROXY_H__FA48B199_B231_4E5E_963E_CADDA08FD3BB__INCLUDED_)
